Package net.shibboleth.idp.attribute.filter

# Interface Matcher

All Superinterfaces:
  `Component`, `IdentifiedComponent`

All Known Implementing Classes:
  `AbstractComposedMatcher`, `AbstractMatcher`, `AbstractMatchesShibMDScopeMatcher`, `AbstractRegexpStringMatcher`, `AbstractStringMatcher`, `AndMatcher`, `AttributeInMetadataMatcher`, `AttributeScopeMatchesShibMDScope`, `AttributeScopeRegexpMatcher`, `AttributeScopeStringMatcher`, `AttributeValueMatchesShibMDScope`, `AttributeValueRegexpMatcher`, `AttributeValueStringMatcher`, `MatcherFromPolicy`, `MockMatcher`, `NotMatcher`, `OrMatcher`, `ScriptedMatcher`

@ThreadSafe public interface Matcher extends IdentifiedComponent
Java definition of MatchFunctorType as applied to value filtering.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final Matcher`
`MATCHER_FAILS`
A `Matcher` that fails.
`static final Matcher`
`MATCHES_ALL`
A `Matcher` that returns true/all attribute values as matched.
`static final Matcher`
`MATCHES_NONE`
A `Matcher` that returns false/no attribute values as matched.

## Method Summary

Modifier and Type
Method
Description
`Set<IdPAttributeValue>`
`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.

### Methods inherited from interface net.shibboleth.shared.component.IdentifiedComponent

`getId`

## Field Details

### MATCHES_ALL

@Nonnull static final Matcher MATCHES_ALL
A `Matcher` that returns true/all attribute values as matched.

### MATCHES_NONE

@Nonnull static final Matcher MATCHES_NONE
A `Matcher` that returns false/no attribute values as matched.

### MATCHER_FAILS

@Nonnull static final Matcher MATCHER_FAILS
A `Matcher` that fails. targetted primarily at testing, but also at odd corners of parsing.

## Method Details

### getMatchingValues

@Nullable @Unmodifiable @NotLive Set<IdPAttributeValue> getMatchingValues(@Nonnull IdPAttribute attribute, @Nonnull AttributeFilterContext filterContext)
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.

Parameters:
  `attribute` - the attribute under question.
  `filterContext` - the filter context
Returns:
  The result of this rule. Null if we failed.